Subject: bug#47320: Improve failure reporting in test/lisp/electrict-tests.el

From: Alan Mackenzie <[email-masked]>
Date: Thu, 25 Mar 2021 13:43:27 +0000

Hello, Jaão.

On Wed, Mar 24, 2021 at 20:10:48 +0000, João Távora wrote:
> > I just committed the patch as it was.  Sorry.

> I don't much see the point in asking for comments from people
> and then proceeding to ignore the simplest request for adjustments
> outright.

The requests were only simple on the surface.  Even though the original
change took me around about an hour (it was at ~03-00 a.m. one sleepless
night in 2019), I've spent a large part of two days trying to use the
ert facilities without reading its source (they are essentially
undocumented).

I misunderstood your suggestion as suggesting outputting the doc-string
using ert-fail.  In the end I couldn't get that to work, as I said.

> You did write "if there are no objections...". Well I had a small
> objection. I get it that following Michael's idea, which is probably
> better, takes a little bit more work, but a simple adjustment
> to avoid code repetition could certainly be accommodated.

> FWIW I've quickly tried with this version and it seems to work
> fine:

> (defun electric-pair-test-for (fixture where char expected-string
>                                        expected-point mode bindings
>                                        fixture-fn &optional doc-string)
>   (with-temp-buffer
>     (funcall mode)
>     (insert fixture)
>     (save-electric-modes
>       (let ((last-command-event char)
>             (transient-mark-mode 'lambda))
>         (goto-char where)
>         (funcall fixture-fn)
>         (cl-progv
>             (mapcar #'car bindings)
>             (mapcar #'cdr bindings)
>           (call-interactively (key-binding `[,last-command-event])))))
>     (unless (equal (buffer-substring-no-properties (point-min) (point-max))
>                    expected-string)
>       (when doc-string (message "\n%s\n" doc-string))
>       (ert-fail (format
>                  "buffer contents don't match! (observed %s, expected %s)"
>                  (buffer-string) expected-string)))
>     (unless (equal (point) expected-point)
>       (when doc-string (message "\n%s\n" doc-string))
>       (ert-fail
>        (format "point isn't where it was supposed to be! (observed %s,
> expected %s)"
>                (point) expected-point)))))

OK, I see what you meant now.  This version, instead of duplicating the
test comparisons, duplicates the call to message.  I think it boils down
to ert (particularly its documentation) not being sufficiently advanced
to do what we'd both like.

But if you'd prefer your version, I'd be happy enough to commit it.  I
mainly just want finally to get the amendment off my hands and into
master.

[ .... ]

> -- 
> João Távora

-- 
Alan Mackenzie (Nuremberg, Germany).